// **********************************
//    USB-ADC XBeeK[t@[
//    For PIC18F14K50
// **********************************
//	V1.00	2011.01.31		MPLAB8.60,MPLAB C18 

/** INCLUDES *******************************************************/
#include	"delays.h"
#include	"string.h"
#include	"ctype.h"

/** CONFIGURATION **************************************************/
        //14K50
        #pragma config CPUDIV = NOCLKDIV		// Fosc:24MHz
        #pragma config USBDIV = OFF
        #pragma config FOSC   = IRC
        #pragma config PLLEN  = OFF
        #pragma config PCLKEN = ON
        #pragma config FCMEN  = OFF
        #pragma config IESO   = OFF
        #pragma config PWRTEN = ON
        #pragma config BOREN  = NOSLP		// Sleepɒ~
        #pragma config BORV   = 22			// 2.7V
//        #pragma config VREGEN = ON
        #pragma config WDTEN  = OFF
        #pragma config WDTPS  = 32768
        #pragma config MCLRE  = OFF
        #pragma config HFOFST = OFF
        #pragma config STVREN = ON
        #pragma config LVP    = OFF
        #pragma config XINST  = OFF
        #pragma config BBSIZ  = OFF
        #pragma config CP0    = OFF
        #pragma config CP1    = OFF
        #pragma config CPB    = OFF
        #pragma config WRT0   = OFF
        #pragma config WRT1   = OFF
        #pragma config WRTB   = OFF
        #pragma config WRTC   = OFF
        #pragma config EBTR0  = OFF
        #pragma config EBTR1  = OFF
        #pragma config EBTRB  = OFF       



// *** CONSTANTS ***
#pragma	code

/** V A R I A B L E S ********************************************************/
#pragma udata	DATA_AREA=0x200

char		USART_In_Buffer[64];	// USART(HostTarget)pobt@
char		USART_rxbuf[64];		// USART͈s̓obt@
char		USART_rxcnt;			// USARTMJE^
long		USART_txnum;			// USARTMf[^
char		data_buffer[16];
int			samp_time;

union {								// 荞ݗptO
	struct {
		unsigned char	TIMEC_SET:1;
		unsigned char	TIMEC_UP:1;
		unsigned char	TIMEC10MS_SET:1;
		unsigned char	TIMEC10MS_UP:1;
	};
	unsigned char data;
} iflag;

char		reg_md[4][3];			// AD7793@ModeWX^li[
char		reg_cf[4][3];			// AD7793 ConfigWX^li[

union  {							// USARTMtO
	struct {
		unsigned char	RCVING:1;	// bit0 M:1
		unsigned char	RCVEND:1;	// bit1 MI:1
		unsigned char	RDGDMD:1;	// bit2 f[^ǂݏov:1
		unsigned char	CNVEND:1;	// ϊ/ǂݏoI:1
	};
	unsigned char data;
} USART_trflag;

char	strg[32];					// ėp񏈗obt@
unsigned	ADconv_cnt;				// ADϊ񐔊i[(gp)
unsigned	timec;					// 1mSJEgp
unsigned	timec10ms;				// 10mSJEgp


//*** User Define ***
#define	ERR		0
#define	NOERR	1

/** P R I V A T E  P R O T O T Y P E S ***************************************/
void	YourHighPriorityISRCode();
void	InitializeSystem(void);
void	usart_data_tx(char ch);
void	putUSART(char *buf,int n);
void	putrsUSART(const rom char *cp);
void	send_data(long send_data,char *cp);
char	htoc(int ch);
char	SSPtrans(char sch);
char	adread_command(void);
int		ctoh(char ch);
int		hex2int(char *ptr);
char	*int2hex(unsigned char ch,char *cp);
long	htol(char *cp);
void	mon(int pt);
void	AD_reset(void);
void	wait_timec(unsigned n);
int		wait_uart_recv(int tmout);
void	string_copy_term(char *dch,const char *sch);
char	check_xbee_myid();
int		read_ad_param(char id);
void	single_conv(char *dtbuf,int adch);
void	all_channel_conv(void);
void	conv_data_send(void);
void	start_usart(void);
void	stop_usart(void);

//*** Interrpt Vector ***
#pragma interrupt	int_npty
#pragma code high_vector = 0x08
void	isr(void)
{ _asm goto int_npty _endasm }

#pragma code 
void int_npty(void)
{
	static	unsigned int	cnt10ms,i_timec,i_timec10ms;
	static	char	i_rch,*i_cpd;

	// *** Timer0 1mSTCN荞ݏ ***
	if  (INTCONbits.TMR0IF) {			// Timer0 ?
		TMR0L = 0x84;    				// TMR0Ɏc125(0x7d)Zbg
		INTCONbits.TMR0IF = 0;			// ^C}0荞݃tONA
		if(iflag.TIMEC_SET==1) {		// lZbgi[hr̕ύXh~j
			i_timec = timec;
			iflag.TIMEC_SET = 0;
		}
		if(iflag.TIMEC10MS_SET==1) {	// lZbgi[hr̕ύXh~j
			i_timec10ms = timec10ms;
			iflag.TIMEC10MS_SET = 0;
		}
		if(i_timec != 0) {				// 1msEFCgpJE^0łȂ-1
			if(--i_timec==0) iflag.TIMEC_UP = 1;
		}
		if(++cnt10ms>=10) {				// 10msJEg
			cnt10ms = 0;
			if(i_timec10ms != 0) {		// 10msEFCgpJE^0łȂ-1
				if(--i_timec10ms ==0) iflag.TIMEC10MS_UP = 1;
			}
		}
	} 
	if (PIR1bits.RCIF) {				// USARTM荞
		i_rch = RCREG;
		PIR1bits.RCIF = 0;
		if (RCSTAbits.FERR==1) {
			RCSTAbits.FERR=0;
		} else if (USART_trflag.RCVEND == 0) {			// M񂪂܂ĂȂꍇAXLbv
			if((USART_rxcnt)>sizeof(USART_rxbuf)) {
				USART_rxcnt = 0;
				USART_trflag.data &= ~0x3;
			} else {
				i_cpd = USART_rxbuf+USART_rxcnt;
				USART_rxcnt++;
				if ((i_rch == 0xa) || (i_rch == 0xd) || (i_rch == '\0')) {
					*i_cpd = '\0';
					USART_trflag.RCVEND = 1;			// MItO
				} else {
//					if (islower(i_rch)!=0) i_rch=toupper(i_rch);	// 啶ɕϊ
					*i_cpd = i_rch;
				}
			}
		}
	}
}

#pragma code

#define	AD_CS	LATCbits.LATC6	// AD7793 /CS
#define	AD_RDY	PORTBbits.SDI	// AD7793 /RDY
#define	XBee_PD	LATCbits.LATC4
#define	LEDON	LATCbits.LATC5 = 0
#define	LEDOF	LATCbits.LATC5 = 1

// *** 2Xe[g ***
void	InitADC(void)
{
	char	rch;
	AD_reset();

	wait_timec(2);
	Nop();	    				// fBC
	rch = SSPtrans(0x08);		// [hWX^ Write Command
	rch = SSPtrans(0x00);		// Aϊ
	rch = SSPtrans(0x0a);		// CLKA16.7Hz
	Nop();
	rch = SSPtrans(0x10);		// ݒ背WX^ Write Command
	rch = SSPtrans(0x50);		// VBias1 on,*1,Unipoler
	rch = SSPtrans(0x80);		// IntRef,nonBuf,Ain1+-Ain1-
}

const char	cmd_at[] = "+++";
const char	cmd_my[] = "ATMY";
const char	cmd_cn[] = "ATCN";
const char	cmd_resp[] = "OK";

#define	SEARCH_TIME	6000	// Tԁ@60b

// XBeeIDǂݏo
// return : ID()
char		check_xbee_myid()
{
	char	ch;

	XBee_PD = 0;
	wait_timec(14);
	string_copy_term(strg,cmd_at);
	putUSART(strg,3);							// "+++" M
	if (wait_uart_recv(100) == -1) return -1;	// bԕԐM҂
	if (strncmp(USART_rxbuf,cmd_resp,2) != 0) return -1;	// "OK"H
	string_copy_term(strg,cmd_my);				// "ATMY" MYAhXvM
	putUSART(strg,6);
	if (wait_uart_recv(100) == -1) return -1;	//  bԕԐM҂
	ch = USART_rxbuf[0];						// MYIDǂݏo
	string_copy_term(strg,cmd_cn);				// "ATCN" ATR}hI
	putUSART(strg,6);
	if (wait_uart_recv(10) == -1) return -1;	// bԕԐM҂
	if (strncmp(USART_rxbuf,cmd_resp,2) != 0) return -1;	// "OK"H
	return ch;
}

// p\R瑪p[^M
// "@N"Ŏn܂4CH̃RtBM[VWX^A[hWX^f[^
int	read_ad_param(char id)
{
	int	i,ip;
	char	*cp;

	USART_trflag.RCVEND=0;
	strg[0] = '@';
	strg[1] = id;
	for(i=0;i<SEARCH_TIME;i++) {
		if (USART_trflag.RCVEND == 1) {
			if (strncmp(USART_rxbuf,strg,2) == 0) {
				cp = USART_rxbuf + 2;
				for(ip=0;ip<4;ip++) {
					reg_cf[ip][2] = hex2int(cp);
					cp += 2;
					reg_cf[ip][1] = hex2int(cp);
					cp += 2;
					reg_cf[ip][0] = hex2int(cp);
					cp += 2;
					reg_md[ip][2] = hex2int(cp);
					cp += 2;
					reg_md[ip][1] = hex2int(cp);
					cp += 2;
					reg_md[ip][0] = hex2int(cp);
					cp += 2;
				}
				samp_time = hex2int(cp) * 100;
				return 1;
			}
			USART_trflag.data &= ~0x3;
			USART_rxcnt = 0;
		}
		if ((i % 100)<10) LEDON; else LEDOF;
		wait_timec(10);
	}
	LEDOF;
	return -1;
}

// USARTsŏIf[^tmout*10ms҂
// return : MA^CAEg-1
int	wait_uart_recv(int tmout)
{
	int	i;

	i = 0;
	while(USART_trflag.RCVEND!=1) {
		wait_timec(10);
		if (++i > tmout) return(-1);
	}
	i = USART_rxcnt;
	USART_trflag.data &= ~0x3;
	USART_rxcnt = 0;
	return i;
}

#define	DELAY1ST	330				// EFCg3.3b
// C[v
void main(void)
{   
	char	*cpd,*cps,flag,rch,id;
	int	i,j,rt,adcnt,deff;

    InitializeSystem();

	AD_CS = 0;
	wait_timec(100);
	InitADC(); 						// ADC
	adcnt = 0;
	flag = 0;
	start_usart();					// USARTM荞݃X^[g
	deff = 0;
	id = check_xbee_myid();			// XBeeidǂݏo
	if (read_ad_param(id) == -1) {	// ADRo[^̐ݒlp\R瓾
		Nop();			    		//@sX[vA~
		rch = SSPtrans(0x08);		// AD7793p[_E[h
		rch = SSPtrans(0x60);
		rch = SSPtrans(0x4A);

		INTCONbits.PEIE=0;
		INTCONbits.GIE = 0;
		XBee_PD = 1;
		Sleep();
		for(;;);
	} else {						// '@'+idԐM
		strg[0]='@';
		strg[1]=id;
		strg[2]=0xd;
		strg[3]=0xa;
		putUSART(strg,4);
	}
	stop_usart();

	timec10ms = DELAY1ST;			// ̎q@T[`҂ȂPADϊ
	iflag.TIMEC10MS_SET = 1;		// TvԃZbg
	while(iflag.TIMEC10MS_SET==1);
	all_channel_conv();
	while(iflag.TIMEC10MS_UP==0);	// TvԃEFCg
	iflag.TIMEC10MS_UP=0;

	while(1) {
		timec10ms = samp_time + deff;
		iflag.TIMEC10MS_SET = 1;		// TvԃZbg
		while(iflag.TIMEC10MS_SET==1);
		deff = 0;
		LEDON;
		XBee_PD = 0;
		wait_timec(14);
		strg[0] = '@';
		strg[1] = id;
		putUSART(strg,2);
		conv_data_send();		
		strg[0] = 0xd;
		strg[1] = 0xa;
		start_usart();
		putUSART(strg,2);
		for(i=0;i<100;i++) {
			if(USART_trflag.RCVEND==1) {
				if(USART_rxbuf[1]==id) {
					i=hex2int(USART_rxbuf+2);	// ԍǂݏoZbgi}50msj
					if(i>0x80) i=0x80-i;
					if (i>0) {
						deff = -5;
					} else {
						deff = 5;
					}
					goto lll;
				}
			}
			wait_timec(10);
		}
lll:
		stop_usart();
		wait_timec(10);
		XBee_PD = 1;
		adcnt++;
		all_channel_conv();
		LEDOF;
		while(iflag.TIMEC10MS_UP==0);	// TvԃEFCg
		iflag.TIMEC10MS_UP=0;
	}
}

void	single_conv(char *dtbuf,int adch)
{
	char	rch;

	rch = SSPtrans(reg_cf[adch][2]);	// ConfigReg MSB
	rch = SSPtrans(reg_cf[adch][1]);
	rch = SSPtrans(reg_cf[adch][0]);
	rch = SSPtrans(reg_md[adch][2]);	// ModeReg MSB
	rch = SSPtrans(reg_md[adch][1]);
	rch = SSPtrans(reg_md[adch][0]);

	Nop();			    				// fBC
	while (AD_RDY == 1) {
	}
	rch = SSPtrans(0x58);			// Data Reg Read Command
	*dtbuf++ = SSPtrans(0x00);
	*dtbuf++ = SSPtrans(0x00);
	*dtbuf++ = SSPtrans(0x00);
	wait_timec(2);
}

// S`l`cϊf[^i[
void	all_channel_conv(void)
{
	Nop();	
	single_conv(data_buffer,0);
	single_conv(data_buffer+3,1);
	single_conv(data_buffer+6,2);
	single_conv(data_buffer+9,3);
}

// ϊf[^VAM
void	conv_data_send(void)
{
	int	i;
	char	*cpd,*cps;

	cps = data_buffer;
	cpd = strg;
	for(i=0;i<4;i++) {
		cpd = strg;
		cpd = int2hex(*cps++,cpd);
		cpd = int2hex(*cps++,cpd);
		cpd = int2hex(*cps++,cpd);
		putUSART(strg,6);
	}
}

//********************************
//  SPIM
//********************************
// Entry	sch : M
// Exit	M
// M̎̓_~[𑗐M
char	SSPtrans(char sch)
{
	char	rch;

	SSPBUF = sch;				// f[^
	while(SSPSTATbits.BF==0);	// M҂
	rch = SSPBUF;				// f[^ǂݏo
	PIR1bits.SSPIF = 0;			// SSPIF clear
	return(rch);
}

// *****************
//    UART֐
// *****************
void	start_usart(void)
{
	USART_trflag.data &= ~0x3;
	USART_rxcnt = 0;
	PIR1bits.RCIF = 0;
	PIE1bits.RCIE = 1;
}

void	stop_usart(void)
{
	PIE1bits.RCIE = 1;
}

void	usart_data_tx(char ch)
{
	while(TXSTAbits.TRMT==0) ;
	TXREG = ch;
//	wait_timec(1);
}

char	usart_data_rx()
{
	while(USART_trflag.RCVING==0);
	USART_trflag.RCVING = 0;
	return(USART_In_Buffer[0]);
}

void	putrsU(const rom char *cp)
{
	putrsUSART(cp);
}

void	putU(char *cp,int n)
{
	putUSART(cp,n);
}

void	putrsUSART(const rom char *cp)
{
	while(*cp) {
		usart_data_tx(*cp++);
	}
}

void	putUSART(char *buf,int n)
{
	int	i;

	for(i=0;i<n;i++) {
		usart_data_tx(*buf++);
	}
}


// *** AD7793fW^C^[tF[X̃Zbg(32ȏ1) ***
void	AD_reset(void)
{
	char	rch;

	Nop();
	rch = SSPtrans(0xff);
	rch = SSPtrans(0xff);
	rch = SSPtrans(0xff);
	rch = SSPtrans(0xff);
	rch = SSPtrans(0xff);	// Ô߂8
}

// ********************
//   USARTR}h&
// ********************

// **************
//   ֐
// **************

// *** 1byte(00h-0Fh)PPUi('0'-'F')ɕϊ ***
char	htoc(int ch)
{
	return "0123456789ABCDEF"[ch & 0xf];
}

// *** 1byte16i𐔒lɕϊ ***
int	ctoh(char ch)
{
	if (islower(ch)!=0) ch=toupper(ch);
	if (ch>='A') return(ch-'A'+10); else return(ch-'0');
}

// *** 񒆂2HEXlintɕϊ ***
// Entry	*ptr : w蕶
int	hex2int(char *cp)
{
	int	ctoh();
	unsigned int	ch1,ch2;

	ch1 = (unsigned int)(ctoh(*cp++)<<4)&0xf0;
	ch2 = (unsigned int)(ctoh(*cp))&0xf;
	return(ch1+ch2);
}

// *** 1oCgϐ2HEXɕϊA|C^+2 ***
char	*int2hex(unsigned char ch,char *cp)
{
	*cp++ = htoc(ch >> 4);
	*cp++ = htoc(ch & 0xf);
	return(cp);
}

// *** 16i\Llong^ɕϊ ***
long	htol(char *cp)
{
	long	lval = 0;

	while(*cp != '\0') {
		lval = lval << 4;
		lval += ctoh(*cp++);
	}
	return lval;
}

// *** Longf[^6oCgHEXɕϊ^[~l[^t ***
void send_data(long send_data,char *cp)
{
	int i;
	unsigned char uch;

	uch = (send_data >> 20) & 0xf;
	*cp++ = htoc(uch);
	uch = (send_data >> 16) & 0xf;
	*cp++ = htoc(uch);
	uch = (send_data >> 12) & 0xf;
	*cp++ = htoc(uch);
	uch = (send_data >>  8) & 0xf;
	*cp++ = htoc(uch);
	uch = (send_data >>  4) & 0xf;
	*cp++ = htoc(uch);
	uch = (send_data      ) & 0xf;
	*cp++ = htoc(uch);
	*cp++ = 0xd;
	*cp++ = 0xa;
	*cp++ = '\0';
}

void	string_copy_term(char *dch,const char *sch)
{
	while(*sch!='\0') {
		*dch++ = *sch++;
	}
	*dch++ = 0xd;
	*dch++ = 0xa;
	*dch++ = 0x0;
}

// *********
//   G֐
// *********

// *** pulse mon ***
void	mon(int pt)
{
	int	i;
	for(i=0;i<pt;i++) {
		LATCbits.LATC2 = 1;
		LATCbits.LATC2 = 0;
	}
}

// 1ms~n@EFCg
void	wait_timec(unsigned n)
{
	timec = n;
	iflag.TIMEC_SET = 1;
	while (iflag.TIMEC_UP==0);
	iflag.TIMEC_UP = 0;
}

// *********
//   
// *********
void InitializeSystem(void)
{
	OSCCON = 0x52;			// 4MHz
	USART_rxcnt = 0;
	USART_trflag.data = 0x0;
	iflag.data = 0x0;
	USART_txnum = 0L;
	// ADRo[^
	ANSEL = 0x10;			// AN4:Analog other all Digital
	ANSELH = 0x0;			// AN8-11 all Digital
	ADCON0 = 0x11;			// AN4 Select
	ADCON1 = 0x00;			// Vref Vdd-Vss
	ADCON2 = 0x3e;			// 20Tad,Fosc/64,Left
	// IO|[g
	LATC = 0x50;			// AD7793/CS,XBeeHigh
	LATB = 0x00;
	TRISA = 0xff;			// RA:all in
	TRISB = 0x30;			// RB4,5:in other:out
	TRISC = 0x01;			// RC0:in other:out
	// MSSP(SPI[h)
	SSPSTAT = 0x01;			// SMP:0,CKE:0,BF:full
	SSPCON1 = 0x32;			// NonWC,SSPon,CKP:1,Fosc/64(375KHz)
	// Timer0 
	T0CON = 0xc2;			// Internal 1/8 16bit
	TMR0L = 0x84;    		// TMR0Ɏc125(0x7d)Zbg
	// Timer2 
//	T2CON = 0x16;			// pre:1/16,post:1/3,on
//	IPR1bits.TMR2IP = 1;
	PR2 = 0xfa;

	// USART 
	RCSTA = 0x90;			// USART enable,8bit
	TXSTA = 0x26;			// SYNC=0,BRGH=1
	SPBRG = 103;			// 9600bps
	SPBRGH = 0x0;
	BAUDCON = 0x8;			// DTRXP noninv,CKTXP norm,BRG16=1,ABDEN off
	// 荞݋
	INTCONbits.TMR0IE = 1;	// Timer0 interrupt enable
//	PIE1bits.TMR2IE = 1;	// Timer2 interrupt enable
//	PIE1bits.RCIE = 1;		// USART rx interrupt enable
	INTCONbits.PEIE=1;
	INTCONbits.GIE = 1;
}


